package com.logicbig.example;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.util.MultiValueMap;
import org.springframework.web.bind.annotation.PatchMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping("/articles")
public class ArticleController {

    @Autowired
    private ArticleService articleService;

    //for xml and json
    @PatchMapping("/{id}")
    @ResponseBody
    public String patchArticle(@RequestBody Article article) {
        System.out.println("Article updating in controller: " + article);
        articleService.updateArticle(article.getId(), article.getContent());
        return "Article updated with content: " + article.getContent();
    }

    //for x-www-form-urlencoded
    @PatchMapping(value = "/{id}", consumes = MediaType.APPLICATION_FORM_URLENCODED_VALUE)
    @ResponseBody
    public String patchArticle(@RequestBody MultiValueMap<String, String> formParams) {
        System.out.println(formParams);
        long id = Long.parseLong(formParams.getFirst("id"));
        String content = formParams.getFirst("content");
        articleService.updateArticle(id, content);
        return "Article updated with content: " + content;
    }
}